'
'
' [Quick]Sort $1 array in numerical order.
'
FUNCTION  XstQuickSort_$1 ($1 arr[], XLONG n[], XLONG low, XLONG high, XLONG flags)

	$1 partition
	$1 itemSWAP
	XLONG fOrder, midPoint, nPartition, i, j, iSWAP
'
	IF (low >= high) THEN RETURN								' less than two elements
'
	IF (flags AND $$SortDecreasing) THEN
		fOrder = $$SortDecreasing
	ELSE
		fOrder = $$SortIncreasing
	ENDIF
'
	IF (fOrder = $$SortDecreasing) THEN
		IF ((high - low) = 1) THEN								' two element left
			IF (arr[low] > arr[high]) THEN RETURN			' arr[] correct order
			IF (arr[low] < arr[high]) THEN
				itemSWAP = arr[low] : arr[low] = arr[high] :  arr[high] = itemSWAP			' exchange arr[]'s items
				IF n[] THEN iSWAP = n[low] : n[low] = n[high] :  n[high] = iSWAP			' exchange n[]'s items
			ELSE
				IFZ n[] THEN RETURN										' arr[] equal:  use n[]
				IF (n[low] > n[high]) THEN						' n[] sort $$SortIncreasing
					itemSWAP = arr[low] : arr[low] = arr[high] :  arr[high] = itemSWAP			' exchange arr[]'s items
					iSWAP = n[low] : n[low] = n[high] :  n[high] = iSWAP			' exchange n[]'s items
				ENDIF
			ENDIF
			RETURN
		ENDIF
		midPoint = (high + low) >> 1
		itemSWAP = arr[high] : arr[high] = arr[midPoint] :  arr[midPoint] = itemSWAP			' exchange arr[]'s items
		IF n[] THEN iSWAP = n[high] : n[high] = n[midPoint] :  n[midPoint] = iSWAP			' exchange n[]'s items
		'
		partition = arr[high]
		IF n[] THEN nPartition = n[high]
		i = low: j = high
		DO
			IFZ n[] THEN
				DO WHILE (i < j) AND (arr[i] >= partition)
					INC i
				LOOP
				DO WHILE (j > i) AND (arr[j] <= partition)
					DEC j
				LOOP
			ELSE
				DO WHILE (i < j)
					IF (arr[i] < partition) THEN EXIT DO
					IF (arr[i] = partition) THEN
						IF (n[i] > nPartition) THEN EXIT DO
					ENDIF
					INC i
				LOOP
				DO WHILE (j > i)
					IF (arr[j] > partition) THEN EXIT DO
					IF (arr[j] = partition) THEN
						IF (n[j] < nPartition) THEN EXIT DO
					ENDIF
					DEC j
				LOOP
			ENDIF
			IF (i < j) THEN
				itemSWAP = arr[i] : arr[i] = arr[j] :  arr[j] = itemSWAP			' exchange arr[]'s items
				IF n[] THEN iSWAP = n[i] : n[i] = n[j] :  n[j] = iSWAP			' exchange n[]'s items
			ENDIF
		LOOP WHILE (i < j)
	ELSE
		IF ((high - low) = 1) THEN								' two element left
			IF (arr[low] < arr[high]) THEN RETURN			' arr[] correct order
			IF (arr[low] > arr[high]) THEN
				itemSWAP = arr[low] : arr[low] = arr[high] :  arr[high] = itemSWAP			' exchange arr[]'s items
				IF n[] THEN iSWAP = n[low] : n[low] = n[high] :  n[high] = iSWAP			' exchange n[]'s items
			ELSE
				IFZ n[] THEN RETURN										' arr[] equal:  use n[]
				IF (n[low] > n[high]) THEN						' n[] sort $$SortIncreasing
					itemSWAP = arr[low] : arr[low] = arr[high] :  arr[high] = itemSWAP			' exchange arr[]'s items
					iSWAP = n[low] : n[low] = n[high] :  n[high] = iSWAP			' exchange n[]'s items
				ENDIF
			ENDIF
			RETURN
		ENDIF
		midPoint = (high + low) >> 1
		itemSWAP = arr[high] : arr[high] = arr[midPoint] :  arr[midPoint] = itemSWAP			' exchange arr[]'s items
		IF n[] THEN iSWAP = n[high] : n[high] = n[midPoint] :  n[midPoint] = iSWAP			' exchange n[]'s items
		'
		partition = arr[high]
		IF n[] THEN nPartition = n[high]
		i = low: j = high
		DO
			IFZ n[] THEN
				DO WHILE (i < j) AND (arr[i] <= partition)
					INC i
				LOOP
				DO WHILE (j > i) AND (arr[j] >= partition)
					DEC j
				LOOP
			ELSE
				DO WHILE (i < j)
					IF (arr[i] > partition) THEN EXIT DO
					IF (arr[i] = partition) THEN
						IF (n[i] > nPartition) THEN EXIT DO
					ENDIF
					INC i
				LOOP
				DO WHILE (j > i)
					IF (arr[j] < partition) THEN EXIT DO
					IF (arr[j] = partition) THEN
						IF (n[j] < nPartition) THEN EXIT DO
					ENDIF
					DEC j
				LOOP
			ENDIF
			IF (i < j) THEN
				itemSWAP = arr[i] : arr[i] = arr[j] :  arr[j] = itemSWAP			' exchange arr[]'s items
				IF n[] THEN iSWAP = n[i] : n[i] = n[j] :  n[j] = iSWAP			' exchange n[]'s items
			ENDIF
		LOOP WHILE (i < j)
	ENDIF
'
	itemSWAP = arr[i] : arr[i] = arr[high] :  arr[high] = itemSWAP			' exchange arr[]'s items
	IF n[] THEN iSWAP = n[i] : n[i] = n[high] :  n[high] = iSWAP			' exchange n[]'s items
'
	IF (i > (low + 1)) THEN XstQuickSort_$1 (@arr[], @n[], low, (i-1), fOrder)
	IF (i < (high - 1)) THEN XstQuickSort_$1 (@arr[], @n[], (i+1), high, fOrder)
'
END FUNCTION