
FUNCTION $1_Active ($1_id)
	SHARED $1_poolUM[]

	slot = $1_id - 1
	IF (slot >= 0) && (slot <= UBOUND ($1_poolUM[])) THEN
		IF $1_poolUM[slot] THEN RETURN $$TRUE
	ENDIF
END FUNCTION

FUNCTION $1_Get_count ()
	SHARED $1_poolUM[]

	count = 0
	IF $1_poolUM[] THEN
		FOR slot = UBOUND ($1_poolUM[]) TO 0 STEP -1
			IF $1_poolUM[slot] THEN INC count
		NEXT slot
	ENDIF
	RETURN count
END FUNCTION

FUNCTION $1_Get_idMin ()
	SHARED $1_poolUM[]

	idMin = 0
	IF $1_poolUM[] THEN
		upper_slot = UBOUND ($1_poolUM[])
		FOR slot = 0 TO upper_slot
			IF $1_poolUM[slot] THEN
				idMin = slot + 1
				EXIT FOR
			ENDIF
		NEXT slot
	ENDIF
	RETURN idMin
END FUNCTION

FUNCTION $1_GetNext (@$1_id, $1 $1_item)
	SHARED $1 $1_pool[]
	SHARED $1_poolUM[]

	$1 $1_null

	bOK = $$FALSE
	IF $1_poolUM[] THEN
		upper_slot = UBOUND ($1_poolUM[])
		FOR slot = $1_id TO upper_slot
			IF $1_poolUM[slot] THEN
				bOK = $$TRUE
				$1_id = slot + 1
				$1_item = $1_pool[slot]
				EXIT FOR
			ENDIF
		NEXT slot
	ENDIF
	IFF bOK THEN
		$1_item = $1_null
	ENDIF
	RETURN bOK
END FUNCTION