; code borrowed from http://www.7gods.org/coding_sysparm.html
; expects variables $1.a, $1.b, $1.c, $1.d, $1.e, $1.f and $1.ret
;
; i386 code
	mov 	ebx,386
	pushfd
	pop 	eax
	mov 	ecx,eax
	mov 	edx,eax
	xor 	eax,0x40000 	; 386 won't change EFALGS bit 34
	push 	eax
	popfd
	pushfd
	pop 	eax
	xor 	eax,ecx
	je 	>	CPUexit

; i486 code
	add 	ebx,100
	mov 	eax,edx
	mov 	ecx,eax
	xor 	eax,0x200000 	; most 486 won't change EFALGS bit 37
	push 	eax 					; (that is, won't support CPUID)
	popfd
	pushfd
	pop 	eax
	xor 	eax,ecx
	je 	>	CPUexit

; pentium 586+ specific code
	mov	eax,0					; set cpuid argument to 0
	cpuid  						; CPUID instruction

	mov	[$1.a],ebx 	; save ebx in a
	mov	[$1.b],edx 	; save edx in b
	mov	[$1.c],ecx 	; save ecx in c

	mov	eax, 1				; set eax to 1
	cpuid  						; CPUID instruction

	mov	[$1.e],eax 	; save eax in e
	mov	[$1.f],ebx 	; save eax in f

	mov	eax, 1				; set eax to 1
	cpuid  						; CPUID instruction

	xor	ebx,ebx
	mov	bl,ah					; put result into ebx
	mov	eax,100				; set eax to 100
	mul	ebx						; mult ebx by 100
	add	eax,86				; add 86
	mov	ebx,eax

CPUexit:
;	mov	eax,ebx
	mov	[$1.ret],ebx	; move result into ret