'
'
' [Quick]Sort $1 array in alphabetical order.
'
FUNCTION  XstQuickSort_$1 ($1 arr$[], XLONG n[], XLONG low, XLONG high, XLONG flags)

	$1 partition$
	XLONG fOrder, midPoint, nPartition, i, j, iSWAP
'
	IF (low >= high) THEN RETURN								' less than two elements
'
	IF (flags AND $$SortDecreasing) THEN
		fOrder = $$SortDecreasing
	ELSE
		fOrder = $$SortIncreasing
	ENDIF
'
	IF (fOrder = $$SortDecreasing) THEN
		IF ((high - low) = 1) THEN								' two element left
			IF (arr$[low] > arr$[high]) THEN RETURN			' arr$[] correct order
			IF (arr$[low] < arr$[high]) THEN
				SWAP arr$[low], arr$[high]
				IF n[] THEN iSWAP = n[low] : n[low] = n[high] :  n[high] = iSWAP			' exchange n[]'s items
			ELSE
				IFZ n[] THEN RETURN										' arr$[] equal:  use n[]
				IF (n[low] > n[high]) THEN						' n[] sort $$SortIncreasing
					SWAP arr$[low], arr$[high]
					iSWAP = n[low] : n[low] = n[high] :  n[high] = iSWAP			' exchange n[]'s items
				ENDIF
			ENDIF
			RETURN
		ENDIF
		midPoint = (high + low) >> 1
		SWAP arr$[high], arr$[midPoint]
		IF n[] THEN iSWAP = n[high] : n[high] = n[midPoint] :  n[midPoint] = iSWAP			' exchange n[]'s items
		'
		partition$ = arr$[high]
		IF n[] THEN nPartition = n[high]
		i = low: j = high
		DO
			IFZ n[] THEN
				DO WHILE (i < j) AND (arr$[i] >= partition$)
					INC i
				LOOP
				DO WHILE (j > i) AND (arr$[j] <= partition$)
					DEC j
				LOOP
			ELSE
				DO WHILE (i < j)
					IF (arr$[i] < partition$) THEN EXIT DO
					IF (arr$[i] = partition$) THEN
						IF (n[i] > nPartition) THEN EXIT DO
					ENDIF
					INC i
				LOOP
				DO WHILE (j > i)
					IF (arr$[j] > partition$) THEN EXIT DO
					IF (arr$[j] = partition$) THEN
						IF (n[j] < nPartition) THEN EXIT DO
					ENDIF
					DEC j
				LOOP
			ENDIF
			IF (i < j) THEN
				SWAP arr$[i], arr$[j]
				IF n[] THEN iSWAP = n[i] : n[i] = n[j] :  n[j] = iSWAP			' exchange n[]'s items
			ENDIF
		LOOP WHILE (i < j)
	ELSE
		IF ((high - low) = 1) THEN								' two element left
			IF (arr$[low] < arr$[high]) THEN RETURN			' arr$[] correct order
			IF (arr$[low] > arr$[high]) THEN
				SWAP arr$[low], arr$[high]
				IF n[] THEN iSWAP = n[low] : n[low] = n[high] :  n[high] = iSWAP			' exchange n[]'s items
			ELSE
				IFZ n[] THEN RETURN										' arr$[] equal:  use n[]
				IF (n[low] > n[high]) THEN						' n[] sort $$SortIncreasing
					SWAP arr$[low], arr$[high]
					iSWAP = n[low] : n[low] = n[high] :  n[high] = iSWAP			' exchange n[]'s items
				ENDIF
			ENDIF
			RETURN
		ENDIF
		midPoint = (high + low) >> 1
		SWAP arr$[high], arr$[midPoint]
		IF n[] THEN iSWAP = n[high] : n[high] = n[midPoint] :  n[midPoint] = iSWAP			' exchange n[]'s items
		'
		partition$ = arr$[high]
		IF n[] THEN nPartition = n[high]
		i = low: j = high
		DO
			IFZ n[] THEN
				DO WHILE (i < j) AND (arr$[i] <= partition$)
					INC i
				LOOP
				DO WHILE (j > i) AND (arr$[j] >= partition$)
					DEC j
				LOOP
			ELSE
				DO WHILE (i < j)
					IF (arr$[i] > partition$) THEN EXIT DO
					IF (arr$[i] = partition$) THEN
						IF (n[i] > nPartition) THEN EXIT DO
					ENDIF
					INC i
				LOOP
				DO WHILE (j > i)
					IF (arr$[j] < partition$) THEN EXIT DO
					IF (arr$[j] = partition$) THEN
						IF (n[j] < nPartition) THEN EXIT DO
					ENDIF
					DEC j
				LOOP
			ENDIF
			IF (i < j) THEN
				SWAP arr$[i], arr$[j]
				IF n[] THEN iSWAP = n[i] : n[i] = n[j] :  n[j] = iSWAP			' exchange n[]'s items
			ENDIF
		LOOP WHILE (i < j)
	ENDIF
'
	SWAP arr$[i], arr$[high]
	IF n[] THEN iSWAP = n[i] : n[i] = n[high] :  n[high] = iSWAP			' exchange n[]'s items
'
	IF (i > (low + 1)) THEN XstQuickSort_$1 (@arr$[], @n[], low, (i-1), fOrder)
	IF (i < (high - 1)) THEN XstQuickSort_$1 (@arr$[], @n[], (i+1), high, fOrder)
'
END FUNCTION
'
'
'  [Quick]Sort $1 array in alphabetical order, case insensitive.
'
FUNCTION  XstQuickSort_$1_nocase ($1 arr$[], XLONG n[], XLONG low, XLONG high, XLONG flags)

	$1 partition$
	XLONG fOrder, midPoint, nPartition, i, j, iSWAP
'
	IF (low >= high) THEN RETURN								' less than two elements
'
	IF (flags AND $$SortDecreasing) THEN
		fOrder = $$SortDecreasing
	ELSE
		fOrder = $$SortIncreasing
	ENDIF
'
	IF (fOrder = $$SortDecreasing) THEN				' "Z" to "A"
		IF ((high - low) = 1) THEN								' two element left
			IF (UCASE$(arr$[low]) > UCASE$(arr$[high])) THEN RETURN			' arr$[] correct order
			IF (UCASE$(arr$[low]) < UCASE$(arr$[high])) THEN
				SWAP arr$[low], arr$[high]
				IF n[] THEN iSWAP = n[low] : n[low] = n[high] :  n[high] = iSWAP			' exchange n[]'s items
			ELSE
				IFZ n[] THEN RETURN										' arr$[] equal:  use n[]
				IF (n[low] > n[high]) THEN						' n[] sort $$SortIncreasing
					SWAP arr$[low], arr$[high]
					iSWAP = n[low] : n[low] = n[high] :  n[high] = iSWAP			' exchange n[]'s items
				ENDIF
			ENDIF
			RETURN
		ENDIF
		midPoint = (high + low) >> 1
		SWAP arr$[high], arr$[midPoint]
		IF n[] THEN iSWAP = n[high] : n[high] = n[midPoint] :  n[midPoint] = iSWAP			' exchange n[]'s items
		IF n[] THEN nPartition = n[high]
		partition$ = UCASE$(arr$[high])
		i = low: j = high
		DO
			IFZ n[] THEN
				DO WHILE ((i < j) AND (UCASE$(arr$[i]) >= partition$))
					INC i
				LOOP
				DO WHILE ((j > i) AND (UCASE$(arr$[j]) <= partition$))
					DEC j
				LOOP
			ELSE
				DO WHILE (i < j)
					IF (UCASE$(arr$[i]) < partition$) THEN EXIT DO
					IF (UCASE$(arr$[i]) = partition$) THEN
						IF (n[i] > nPartition) THEN EXIT DO
					ENDIF
					INC i
				LOOP
				DO WHILE (j > i)
					IF (UCASE$(arr$[j]) > partition$) THEN EXIT DO
					IF (UCASE$(arr$[j]) = partition$) THEN
						IF (n[j] < nPartition) THEN EXIT DO
					ENDIF
					DEC j
				LOOP
			ENDIF
			IF (i < j) THEN
				SWAP arr$[i], arr$[j]
				IF n[] THEN iSWAP = n[i] : n[i] = n[j] :  n[j] = iSWAP			' exchange n[]'s items
			ENDIF
		LOOP WHILE (i < j)
	ELSE
		IF ((high - low) = 1) THEN								' two element left
			IF (UCASE$(arr$[low]) < UCASE$(arr$[high])) THEN RETURN			' arr$[] correct order
			IF (UCASE$(arr$[low]) > UCASE$(arr$[high])) THEN
				SWAP arr$[low], arr$[high]
				IF n[] THEN iSWAP = n[low] : n[low] = n[high] :  n[high] = iSWAP			' exchange n[]'s items
			ELSE
				IFZ n[] THEN RETURN										' arr$[] equal:  use n[]
				IF (n[low] > n[high]) THEN						' n[] sort $$SortIncreasing
					SWAP arr$[low], arr$[high]
					iSWAP = n[low] : n[low] = n[high] :  n[high] = iSWAP			' exchange n[]'s items
				ENDIF
			ENDIF
			RETURN
		ENDIF
		midPoint = (high + low) >> 1
		SWAP arr$[high], arr$[midPoint]
		IF n[] THEN iSWAP = n[high] : n[high] = n[midPoint] :  n[midPoint] = iSWAP			' exchange n[]'s items
		IF n[] THEN nPartition = n[high]
		partition$ = UCASE$(arr$[high])
		i = low: j = high
		DO
			IFZ n[] THEN
				DO WHILE (i < j) AND (UCASE$(arr$[i]) <= partition$)
					INC i
				LOOP
				DO WHILE (j > i) AND (UCASE$(arr$[j]) >= partition$)
					DEC j
				LOOP
			ELSE
				DO WHILE (i < j)
					IF (UCASE$(arr$[i]) > partition$) THEN EXIT DO
					IF (UCASE$(arr$[i]) = partition$) THEN
						IF (n[i] > nPartition) THEN EXIT DO
					ENDIF
					INC i
				LOOP
				DO WHILE (j > i)
					IF (UCASE$(arr$[j]) < partition$) THEN EXIT DO
					IF (UCASE$(arr$[j]) = partition$) THEN
						IF (n[j] < nPartition) THEN EXIT DO
					ENDIF
					DEC j
				LOOP
			ENDIF
			IF (i < j) THEN
				SWAP arr$[i], arr$[j]
				IF n[] THEN iSWAP = n[i] : n[i] = n[j] :  n[j] = iSWAP			' exchange n[]'s items
			ENDIF
		LOOP WHILE (i < j)
	ENDIF
'
	SWAP arr$[i], arr$[high]
	IF n[] THEN iSWAP = n[i] : n[i] = n[high] :  n[high] = iSWAP			' exchange n[]'s items
'
	IF (i > (low + 1)) THEN XstQuickSort_$1_nocase (@arr$[], @n[], low, (i-1), fOrder)
	IF (i < (high - 1)) THEN XstQuickSort_$1_nocase (@arr$[], @n[], (i+1), high, fOrder)
'
END FUNCTION
'
'
'  [Quick]Sort $1 array in numerical order.
'
FUNCTION  XstQuickSort_Numeric$1 ($1 arr$[], XLONG n[], XLONG low, XLONG high, XLONG flags)

	$1 partition$
	XLONG fOrder, midPoint, nPartition, i, j, iSWAP
'
	IF (low >= high) THEN RETURN								' less than two elements
'
	IF (flags AND $$SortDecreasing) THEN
		fOrder = $$SortDecreasing
	ELSE
		fOrder = $$SortIncreasing
	ENDIF
'
	IF (fOrder = $$SortDecreasing) THEN				' "z" to "A"
		IF ((high - low) = 1) THEN								' two element left
			'IF (arr$[low] > arr$[high]) THEN RETURN			' arr$[] correct order
			IF XstCompareStrings (&arr$[low], $$GT, &arr$[high], fOrder) THEN RETURN			' arr$[] correct order
			'IF (arr$[low] < arr$[high]) THEN
			IF XstCompareStrings (&arr$[low], $$LT, &arr$[high], fOrder) THEN
				SWAP arr$[low], arr$[high]
				IF n[] THEN iSWAP = n[low] : n[low] = n[high] :  n[high] = iSWAP			' exchange n[]'s items
			ELSE
				IFZ n[] THEN RETURN										' arr$[] equal:  use n[]
				IF (n[low] > n[high]) THEN						' n[] sort $$SortIncreasing
					SWAP arr$[low], arr$[high]
					iSWAP = n[low] : n[low] = n[high] :  n[high] = iSWAP			' exchange n[]'s items
				ENDIF
			ENDIF
			RETURN
		ENDIF
		midPoint = (high + low) >> 1
		SWAP arr$[high], arr$[midPoint]
		IF n[] THEN iSWAP = n[high] : n[high] = n[midPoint] :  n[midPoint] = iSWAP			' exchange n[]'s items
		'
		partition$ = arr$[high]
		IF n[] THEN nPartition = n[high]
		i = low: j = high
		DO
			IFZ n[] THEN
				'DO WHILE ((i < j) AND (arr$[i] >= partition$))
				DO WHILE ((i < j) && XstCompareStrings (&arr$[i], $$GE, &partition$, fOrder))
					INC i
				LOOP
				'DO WHILE ((j > i) AND (arr$[j] <= partition$))
				DO WHILE ((j > i) && XstCompareStrings (&arr$[j], $$LE, &partition$, fOrder))
					DEC j
				LOOP
			ELSE
				DO WHILE (i < j)
					'IF (arr$[i] < partition$) THEN EXIT DO
					IF XstCompareStrings (&arr$[i], $$LT, &partition$, fOrder) THEN EXIT DO
					'IF (arr$[i] = partition$) THEN
					IF XstCompareStrings (&arr$[i], $$EQ, &partition$, fOrder) THEN
						IF (n[i] > nPartition) THEN EXIT DO
					ENDIF
					INC i
				LOOP
				DO WHILE (j > i)
					'IF (arr$[j] > partition$) THEN EXIT DO
					IF XstCompareStrings (&arr$[j], $$GT, &partition$, fOrder) THEN EXIT DO
					'IF (arr$[j] = partition$) THEN
					IF XstCompareStrings (&arr$[j], $$EQ, &partition$, fOrder) THEN
						IF (n[j] < nPartition) THEN EXIT DO
					ENDIF
					DEC j
				LOOP
			ENDIF
			IF (i < j) THEN
				SWAP arr$[i], arr$[j]
				IF n[] THEN iSWAP = n[i] : n[i] = n[j] :  n[j] = iSWAP			' exchange n[]'s items
			ENDIF
		LOOP WHILE (i < j)
	ELSE
		IF ((high - low) = 1) THEN								' two element left
			'IF (arr$[low] < arr$[high]) THEN RETURN			' arr$[] correct order
			IF XstCompareStrings (&arr$[low], $$LT, &arr$[high], fOrder) THEN RETURN			' arr$[] correct order
			'IF (arr$[low] > arr$[high]) THEN
			IF XstCompareStrings (&arr$[low], $$GT, &arr$[high], fOrder) THEN
				SWAP arr$[low], arr$[high]
				IF n[] THEN iSWAP = n[low] : n[low] = n[high] :  n[high] = iSWAP			' exchange n[]'s items
			ELSE
				IFZ n[] THEN RETURN										' arr$[] equal:  use n[]
				IF (n[low] > n[high]) THEN						' n[] sort $$SortIncreasing
					SWAP arr$[low], arr$[high]
					iSWAP = n[low] : n[low] = n[high] :  n[high] = iSWAP			' exchange n[]'s items
				ENDIF
			ENDIF
			RETURN
		ENDIF
		midPoint = (high + low) >> 1
		SWAP arr$[high], arr$[midPoint]
		IF n[] THEN iSWAP = n[high] : n[high] = n[midPoint] :  n[midPoint] = iSWAP			' exchange n[]'s items
		'
		partition$ = arr$[high]
		IF n[] THEN nPartition = n[high]
		i = low: j = high
		DO
			IFZ n[] THEN
				'DO WHILE (i < j) AND (arr$[i] <= partition$)
				DO WHILE (i < j) && XstCompareStrings (&arr$[i], $$LE, &partition$, fOrder)
					INC i
				LOOP
				'DO WHILE (j > i) AND (arr$[j] >= partition$)
				DO WHILE (j > i) && XstCompareStrings (&arr$[j], $$GE, &partition$, fOrder)
					DEC j
				LOOP
			ELSE
				DO WHILE (i < j)
					'IF (arr$[i] > partition$) THEN EXIT DO
					IF XstCompareStrings (&arr$[i], $$GT, &partition$, fOrder) THEN EXIT DO
					'IF (arr$[i] = partition$) THEN
					IF XstCompareStrings (&arr$[i], $$EQ, &partition$, fOrder) THEN
						IF (n[i] > nPartition) THEN EXIT DO
					ENDIF
					INC i
				LOOP
				DO WHILE (j > i)
					'IF (arr$[j] < partition$) THEN EXIT DO
					IF XstCompareStrings (&arr$[j], $$LT, &partition$, fOrder) THEN EXIT DO
					'IF (arr$[j] = partition$) THEN
					IF XstCompareStrings (&arr$[j], $$EQ, &partition$, fOrder) THEN
						IF (n[j] < nPartition) THEN EXIT DO
					ENDIF
					DEC j
				LOOP
			ENDIF
			IF (i < j) THEN
				SWAP arr$[i], arr$[j]
				IF n[] THEN iSWAP = n[i] : n[i] = n[j] :  n[j] = iSWAP			' exchange n[]'s items
			ENDIF
		LOOP WHILE (i < j)
	ENDIF
'
	SWAP arr$[i], arr$[high]
	IF n[] THEN iSWAP = n[i] : n[i] = n[high] :  n[high] = iSWAP			' exchange n[]'s items
'
	IF (i > (low + 1)) THEN XstQuickSort_Numeric$1 (@arr$[], @n[], low, (i-1), fOrder)
	IF (i < (high - 1)) THEN XstQuickSort_Numeric$1 (@arr$[], @n[], (i+1), high, fOrder)
'
END FUNCTION