; Zero memory (386 and above code)
; - $1: FUNCTION name
; - $2: unique jump tag inside FUNCTION $1
;
; Usage:
; --- XBLite code to uncomment ---
;	'ZeroMemory (&WIN_pool[0], SIZE (WIN_pool[]))
;
;	destAddr = &WIN_pool[0]
;	bytes = SIZE (WIN_pool[])
;
;GRAB "verbose\\ZeroMemory.asm"
;' "$1" := "GenReorg"
;' "$2" := "Z001"

	push	edi
	push	ecx

	mov	ecx,[$1.sourceAddr]
	jecxz > $1.$2.zero.end
	mov edi,ecx

	mov	ecx,[$1.bytes]
	jecxz > $1.$2.zero.end

	shr	ecx,2
	jecxz > $1.$2.zero.tail
	mov	eax,0
	cld
	rep stosd

$1.$2.zero.tail:
	mov	ecx,[$1.bytes]
	and	ecx,3
	jecxz > $1.$2.zero.end
	mov	eax,0
	cld
	rep stosb

$1.$2.zero.end:
	pop	ecx
	pop	edi
